
open Cfg
open Utils
(*
type cast = [
  `Class_Has_Instance_Method
| `Class_Has_Class_Method
| `Instance_Has_Instance_Method
]

let insert_casts translations results stmt = 
  let xlate snode = 
    let s = mkstmt snode stmt.pos in
      Hashtbl.add results stmt.sid s.sid;
      try 
	let _ = Hashtbl.find translations stmt.sid in
	  s
      with Not_found -> s
  in
  let rec recurse stmt = match stmt.snode with
    | If(g,ts,fs) -> xlate (If(g,recurse ts,recurse fs))
	
    | Seq(sl) -> xlate (Seq (List.map recurse sl))
	
    | Module(m,s,t) -> xlate (Module(m,recurse s,t))
    | Method(n,p,s,t) -> xlate (Method(n,p,recurse s,t))
    | Class(n,s,t) -> xlate (Class(n,recurse s, t))
    | Begin(s) -> xlate (Begin (recurse s))
    | End(s) -> xlate (End (recurse s))

    | While(s,body) -> xlate (While(recurse s, recurse body))
    | For(b,g,body) -> xlate (For(b, g, recurse body))

    | Case(c) ->
	let c' = {
	  case_guard = c.case_guard;
	  case_whens = 
	    List.map (fun (w,b) -> w, recurse b) c.case_whens;
	  case_else = map_opt recurse c.case_else;
	} in
	  xlate (Case c')

    | MethodCall(l,mc) -> 
	let mc' = 
	  {mc with 
	     mc_cb = map_opt 
	      (fun x -> 
		 {x with cb_body=recurse x.cb_body}
	      ) mc.mc_cb
	  }
	in
	  xlate (MethodCall(l,mc'))
	    
    | ExnBlock(b) ->
	let b' = 
	  {exn_body = recurse b.exn_body;
	   exn_rescue = 
	      List.map
		(fun r ->
		   {r with rescue_body = recurse r.rescue_body}
		) b.exn_rescue;
	   exn_ensure = map_opt recurse b.exn_ensure;
	   exn_else = map_opt recurse b.exn_else;
	  } in
	  xlate (ExnBlock b')

    | Undef _
    | Next _ | Retry | Redo | Break _
    | Defined _
    | Alias _
    | Assign _
    | Expression _
    | Return _
    | Yield _ -> xlate stmt.snode
  in
    recurse stmt
*)
