(* This file tests on handling dynamic features of the Ruby language *)
open Printf
open Cfg

let _ = 
  if (Array.length Sys.argv) <= 1
  then begin
    eprintf "Usage: test_dyn_feats <filename>\n";
    exit 1
  end;
  let fname = Sys.argv.(1) in
  let () = Config.conf.Config.dyn_feats <- true in
  let () = Dyn_feats.run_test fname in
  let mod_ast_f ast = 
    Ast.mod_ast Dyn_feats.transform_evals_expr ast
  in
  let loader = File_loader.create ".:../../std-lib" in
  let () =
    let for_each_file fname =
      let cfg = File_loader.load_file loader ~mod_ast_f:mod_ast_f fname in
      let cfg = Cfg_scope.resolve_scopes loader cfg in
      let () = Cfg_printer.print_stmt stdout cfg in
        ()
    in
      List.iter for_each_file !Dyn_feats.rb_files
  in
    ()
  
