
let contents = ref ""

let rec read_lines in_chan =
  let line = (input_line in_chan) ^ "\n%def%"  in
    (* print_endline line; *)
    (
    try 
      let lexbuf = Lexing.from_string line in
      let t_annot_opt = TypeAnnotParser.input TypeAnnotLexer.token lexbuf in
        print_string
          (Utils.format_to_string TypeAnnot_helper.format_type_annot_opt
            t_annot_opt)
    with (TypeAnnot_helper.TypeAnnot_parse_error t_annot_pos) -> 
      Printf.printf "Parsing error in type annotation at Line %i\n"
        (t_annot_pos.Lexing.pos_lnum)
    ) ;
    print_endline "";
    flush stdout;
    read_lines in_chan

let main filename =
  let in_file = open_in filename in
    print_endline "Start testing...";
    try 
      read_lines in_file
    with End_of_file -> close_in in_file;
    print_endline "Finished testing..."

let _ = main (Array.get Sys.argv 1)

